/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class DirektkandidatExtendedDAO extends AbstractDirektkandidatDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: GebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS(SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet.gebiet = ?1 AND gruppeImGebiet = wahlvorschlag.gruppeImGebiet)<br>
* SQL: <br>
*/
@Override
public java.util.List<Direktkandidat> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidat.findByGebiet" ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Miss");
        }

        cache.put(key, super.findByGebiet( gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Direktkandidat>) cache.lookup(key));
    }

    return super.findByGebiet( gebiet  );
}
/**
* Name: GruppeAndGebietNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT wahlvorschlag FROM Direktkandidat wahlvorschlag WHERE EXISTS (SELECT gruppeImGebiet FROM GruppeImGebiet gruppeImGebiet WHERE gruppeImGebiet = wahlvorschlag.gruppeImGebiet AND gruppeImGebiet.gruppe = ?1 AND gruppeImGebiet.gebiet = ?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<Direktkandidat> findByGruppeAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Direktkandidat.findByGruppeAndGebiet" ,  gruppe ,  gebiet  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByGruppeAndGebiet(): Miss");
        }

        cache.put(key, super.findByGruppeAndGebiet( gruppe ,  gebiet  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByGruppeAndGebiet(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Direktkandidat>) cache.lookup(key));
    }

    return super.findByGruppeAndGebiet( gruppe ,  gebiet  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
